//
//  saveMNIST.cpp
//
//
//  Created by Roni Mittelman on 7/1/13.
//
//


#include <fstream>
#include <iostream>
#include <valarray>
#include <matrix.h>
#include <mat.h>
#include <mex.h>

using namespace std;
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
    ofstream outfile;
    char varname[]={"Data"};
    char *filename;
    char *out_filname;
    int number_of_dims;
    int  *tmp_dims;
    double tmp_read;
    mxArray *X;
    mxArray *X2;
    double* pr;;
    MATFile *matFILE;
    int num_of_videos;
    int T;
    int NVisible;
    int i,j,k;

    if (nrhs!=2){
        cout << "mat2dat requires the name of the input mat file, and output dat file\n";
        return;
    }
    filename = mxArrayToString(prhs[0]);
    out_filname = mxArrayToString(prhs[1]);
    if( (matFILE = matOpen(filename, "r" )) == NULL ){
        printf("Error Opening File: %s\n",filename);
        //return -1;
    }
    X = matGetVariable(matFILE, varname);
    tmp_dims=(int*)mxGetDimensions(X);
    if (tmp_dims[0]==1){
        num_of_videos=tmp_dims[1];
    }
    else{
        num_of_videos=tmp_dims[0];
    }
    
    outfile.open(out_filname);
    outfile << (double)num_of_videos << endl;
    for (int video_ind=0; video_ind<num_of_videos;video_ind++){
        X2=mxGetCell(X, video_ind);
        tmp_dims=(int*)mxGetDimensions(X2);
        T=tmp_dims[0];
        outfile << (double)T << endl;
        NVisible=tmp_dims[1];
        outfile << (double)NVisible << endl;
        pr = mxGetPr(X2);
        for (i=0;i<NVisible;i++){
            for (j=0;j<T;j++){
                outfile<<pr[j+T*i]<< endl;
            }
        }
    }
    outfile.close();
}
