//
//  savRBMCounts.cpp
//
//
//  Created by Roni Mittelman on 7/22/13.
//
//

//#include "saveCodeBooks.h"

#include <fstream>
#include <iostream>
#include <valarray>
#include <matrix.h>
#include <mat.h>
#include <mex.h>

using namespace std;
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
    ifstream infile;
    int i,j;
    int  *tmp_dims;
    double tmp_read;
    
    if( (nrhs > 1) || (nrhs==0) ){
        printf("readW reuires one parameter");
        return;
    }
    if( nlhs < 5 ){
        printf("readW reuires at least five output parameters");
        return;
    }
    
    ////////////
    char *filename = mxArrayToString(prhs[0]);
    infile.open(filename);
    infile >> tmp_read;
    int NVisible=(int)tmp_read;
    infile >> tmp_read;
    int NHidden=(int)tmp_read;
    
    infile >> tmp_read;
    int flag_binary_hist=(int)tmp_read;
    
    double *pr;
    plhs[0]=mxCreateDoubleMatrix(NVisible, NHidden,mxREAL);
    pr = mxGetPr(plhs[0]);
    for (i=0;i<NVisible;i++){
        for (j=0;j<NHidden;j++){
            infile >> tmp_read;
            pr[i+j*NVisible]=tmp_read;
        }
    }
    
    plhs[1]=mxCreateDoubleMatrix(NHidden, NHidden,mxREAL);
    pr = mxGetPr(plhs[1]);
    for (i=0;i<NHidden;i++){
        for (j=0;j<NHidden;j++){
            infile >> tmp_read;
            pr[i+j*NHidden]=tmp_read;
        }
    }
    
    plhs[2]=mxCreateDoubleMatrix(NHidden,1,mxREAL);
    pr = mxGetPr(plhs[2]);
    for (j=0;j<NHidden;j++){
        infile >> tmp_read;
        pr[j]=tmp_read;
    }
    
    plhs[3]=mxCreateDoubleMatrix(NHidden,1,mxREAL);
    pr = mxGetPr(plhs[3]);
    for (j=0;j<NHidden;j++){
        infile >> tmp_read;
        pr[j]=tmp_read;
    }
    
    plhs[4]=mxCreateDoubleMatrix(NVisible,1,mxREAL);
    pr = mxGetPr(plhs[4]);
    for (j=0;j<NVisible;j++){
        infile >> tmp_read;
        pr[j]=tmp_read;
    }
    
    infile >> tmp_read;
    if ((int)tmp_read==1){
        int num_of_nodes;
        infile >> tmp_read;
        num_of_nodes =(int)tmp_read;
        plhs[5]=mxCreateDoubleMatrix(num_of_nodes,num_of_nodes,mxREAL);
        pr = mxGetPr(plhs[5]);
        for (j=0;j<num_of_nodes;j++){
            for (i=0;i<num_of_nodes;i++){
                infile >> tmp_read;
                pr[i+num_of_nodes*j] = tmp_read;
            }
        }
    }
    infile.close();
}