//
//  DBN.cpp
//  
//
//  Created by Roni Mittelman on 7/24/13.
//
//

//#include "saveCodeBooks.h"

#include <fstream>
#include <iostream>
#include <valarray>
#include <vector>
#include "util.h"
#include "RTRBMrelease.h"
#include "ssRTRBMrelease.h"
#ifndef ____ContrastiveDivergence__
#include "ContrastiveDivergence.h"
#endif

int main(int argc, char** argv){
    char filename[200];
    char parameters_filename[200];
    int type;
    int n_CD;
    int num_of_nodes;
    std::valarray<int> NVisible;
    std::valarray<int> NHidden;
    int num_of_iterations;
    float learning_rate;
    float momentum;
    float l1_Theta_reg;
    int flag_learn_mask;
    int flag_causal;
    int flag_share_lambda_parm;
    float alpha_parm;
    float lambda_parm_init;
    float delta_parm, kappa;
    util::read_parms(filename, parameters_filename, &type, &n_CD, &num_of_nodes, &NVisible, &NHidden, &num_of_iterations, &learning_rate, &momentum, &l1_Theta_reg, &flag_learn_mask, &flag_causal, &flag_share_lambda_parm, &alpha_parm, &lambda_parm_init, &delta_parm, &kappa, argv);
    int NVisible0;
    std::vector<std::valarray<float> > data;
    std::valarray<int> Tvct;
    util::read_data(filename, &data, &Tvct, &NVisible0);
    if ((int)NVisible.sum()!=NVisible0){
        std::cout<<"Error: the number of observations in NVisible is different from the number of observations in the data file\n";
        return -1;
    }
    
    int flag_binary_real_ssRBM;
    if ((type==0) ||(type==1)){
        if (type==0){
            flag_binary_real_ssRBM=0;
        }
        else{
            flag_binary_real_ssRBM=2;
        }
        ContrastiveDivergence CD2(n_CD, (int)NHidden.sum(), flag_binary_real_ssRBM);
        RTRBM RBHMM(&CD2, 1, learning_rate, NHidden, NVisible , momentum,l1_Theta_reg, flag_learn_mask, flag_causal, delta_parm, kappa);
        RBHMM.read_parameters(parameters_filename); // load the saved model parameters
        ///////////////////
        if (num_of_iterations==0){
            int n=(int)Tvct.size();
            float tmp_sum=0.0;
            std::valarray<float> error_vct(0.0,n);
            for (int j=0;j<n;j++){
                error_vct[j]=RBHMM.PredictionError2(*(data.begin()+j), Tvct[j]);
                tmp_sum+=error_vct[j];
            }
            std::cout<<"Average prediction error: "<<tmp_sum/n<<"\n";
            float mn=tmp_sum/(float)n;
            std::valarray<float> tmpv0(0.0,n);
            tmpv0=error_vct-mn;
            tmpv0=tmpv0*tmpv0/n;
            float vr=sqrt(tmpv0.sum());
            std::cout<<"standard deviation: "<<vr<<"\n";
        }
        else{
            int n=num_of_iterations;
            for (int j=0;j<(int)Tvct.size();j++){
                float tmp_sum=0.0;
                std::valarray<float> error_vct(0.0,n);
                for (int i=0;i<n;i++){
                    error_vct[i]=RBHMM.PredictionError2(*(data.begin()+j), Tvct[j]);
                    tmp_sum+=error_vct[i];
                }
                std::cout<<"Average prediction error "<<j<<": "<<tmp_sum/n<<"\n";
                float mn=tmp_sum/(float)n;
                std::valarray<float> tmpv0(0.0,n);
                tmpv0=error_vct-mn;
                tmpv0=tmpv0*tmpv0/n;
                float vr=sqrt(tmpv0.sum());
                std::cout<<"standard deviation: "<<j<<": "<<vr<<"\n";
            }
        }
    }
    else{
        if (type==2){
            flag_binary_real_ssRBM=3;
            ContrastiveDivergence CD2(n_CD, (int)NHidden.sum(), flag_binary_real_ssRBM);
            ssRTRBM RBHMM(&CD2, 1, learning_rate, NHidden, NVisible , momentum,l1_Theta_reg, flag_learn_mask, flag_causal, alpha_parm, lambda_parm_init, flag_share_lambda_parm, delta_parm, kappa);
            RBHMM.read_parameters(parameters_filename); // load the saved model parameters
            ///////////////////
            if (num_of_iterations==0){
                int n=(int)Tvct.size();
                float tmp_sum=0.0;
                std::valarray<float> error_vct(0.0,n);
                for (int j=0;j<n;j++){
                    error_vct[j]=RBHMM.PredictionError2(*(data.begin()+j), Tvct[j]);
                    tmp_sum+=error_vct[j];
                }
                std::cout<<"Average prediction error: "<<tmp_sum/n<<"\n";
                float mn=tmp_sum/(float)n;
                std::valarray<float> tmpv0(0.0,n);
                tmpv0=error_vct-mn;
                tmpv0=tmpv0*tmpv0/n;
                float vr=sqrt(tmpv0.sum());
                std::cout<<"standard deviation: "<<vr<<"\n";
            }
            else{
                int n=num_of_iterations;
                for (int j=0;j<(int)Tvct.size();j++){
                    float tmp_sum=0.0;
                    std::valarray<float> error_vct(0.0,n);
                    for (int i=0;i<n;i++){
                        error_vct[i]=RBHMM.PredictionError2(*(data.begin()+j), Tvct[j]);
                        tmp_sum+=error_vct[i];
                    }
                    std::cout<<"Average prediction error "<<j<<": "<<tmp_sum/n<<"\n";
                    float mn=tmp_sum/(float)n;
                    std::valarray<float> tmpv0(0.0,n);
                    tmpv0=error_vct-mn;
                    tmpv0=tmpv0*tmpv0/n;
                    float vr=sqrt(tmpv0.sum());
                    std::cout<<"standard deviation: "<<j<<": "<<vr<<"\n";
                }
            }
        }
    }
    return 0;
}
